-- SPDX-FileCopyrightText: 2022 CERN (home.cern)
--
-- SPDX-License-Identifier: CERN-OHL-W-2.0+

---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Mock Turtle CPU Per-Core Local Registers
---------------------------------------------------------------------------------------
-- File           : mt_cpu_lr_wbgen2_pkg.vhd
-- Author         : auto-generated by wbgen2 from mt_cpu_lr.wb
-- Created        : Mon Jun 11 18:11:01 2018
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE mt_cpu_lr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package mt_cpu_lr_wbgen2_pkg is
  
  
  -- Input registers (user design -> WB slave)
  
  type t_mt_cpu_lr_in_registers is record
    stat_core_id_i                           : std_logic_vector(3 downto 0);
    ntf_int_i                                : std_logic_vector(7 downto 0);
    hmq_stat_in_i                            : std_logic_vector(7 downto 0);
    hmq_stat_out_i                           : std_logic_vector(7 downto 0);
    rmq_stat_in_i                            : std_logic_vector(7 downto 0);
    rmq_stat_out_i                           : std_logic_vector(7 downto 0);
    wr_stat_link_ok_i                        : std_logic;
    wr_stat_time_ok_i                        : std_logic;
    wr_stat_aux_clock_ok_i                   : std_logic_vector(7 downto 0);
    tai_cycles_i                             : std_logic_vector(27 downto 0);
    tai_sec_i                                : std_logic_vector(31 downto 0);
    delay_cnt_i                              : std_logic_vector(31 downto 0);
    gpio_in_i                                : std_logic_vector(31 downto 0);
    end record;
  
  constant c_mt_cpu_lr_in_registers_init_value: t_mt_cpu_lr_in_registers := (
    stat_core_id_i => (others => '0'),
    ntf_int_i => (others => '0'),
    hmq_stat_in_i => (others => '0'),
    hmq_stat_out_i => (others => '0'),
    rmq_stat_in_i => (others => '0'),
    rmq_stat_out_i => (others => '0'),
    wr_stat_link_ok_i => '0',
    wr_stat_time_ok_i => '0',
    wr_stat_aux_clock_ok_i => (others => '0'),
    tai_cycles_i => (others => '0'),
    tai_sec_i => (others => '0'),
    delay_cnt_i => (others => '0'),
    gpio_in_i => (others => '0')
    );
    
    -- Output registers (WB slave -> user design)
    
    type t_mt_cpu_lr_out_registers is record
      ntf_int_o                                : std_logic_vector(7 downto 0);
      ntf_int_load_o                           : std_logic;
      uart_chr_o                               : std_logic_vector(7 downto 0);
      uart_chr_wr_o                            : std_logic;
      delay_cnt_o                              : std_logic_vector(31 downto 0);
      delay_cnt_load_o                         : std_logic;
      gpio_set_o                               : std_logic_vector(31 downto 0);
      gpio_set_wr_o                            : std_logic;
      gpio_clear_o                             : std_logic_vector(31 downto 0);
      gpio_clear_wr_o                          : std_logic;
      end record;
    
    constant c_mt_cpu_lr_out_registers_init_value: t_mt_cpu_lr_out_registers := (
      ntf_int_o => (others => '0'),
      ntf_int_load_o => '0',
      uart_chr_o => (others => '0'),
      uart_chr_wr_o => '0',
      delay_cnt_o => (others => '0'),
      delay_cnt_load_o => '0',
      gpio_set_o => (others => '0'),
      gpio_set_wr_o => '0',
      gpio_clear_o => (others => '0'),
      gpio_clear_wr_o => '0'
      );
    function "or" (left, right: t_mt_cpu_lr_in_registers) return t_mt_cpu_lr_in_registers;
    function f_x_to_zero (x:std_logic) return std_logic;
    function f_x_to_zero (x:std_logic_vector) return std_logic_vector;
end package;

package body mt_cpu_lr_wbgen2_pkg is
function f_x_to_zero (x:std_logic) return std_logic is
begin
if x = '1' then
return '1';
else
return '0';
end if;
end function;
function f_x_to_zero (x:std_logic_vector) return std_logic_vector is
variable tmp: std_logic_vector(x'length-1 downto 0);
begin
for i in 0 to x'length-1 loop
if(x(i) = '1') then
tmp(i):= '1';
else
tmp(i):= '0';
end if; 
end loop; 
return tmp;
end function;
function "or" (left, right: t_mt_cpu_lr_in_registers) return t_mt_cpu_lr_in_registers is
variable tmp: t_mt_cpu_lr_in_registers;
begin
tmp.stat_core_id_i := f_x_to_zero(left.stat_core_id_i) or f_x_to_zero(right.stat_core_id_i);
tmp.ntf_int_i := f_x_to_zero(left.ntf_int_i) or f_x_to_zero(right.ntf_int_i);
tmp.hmq_stat_in_i := f_x_to_zero(left.hmq_stat_in_i) or f_x_to_zero(right.hmq_stat_in_i);
tmp.hmq_stat_out_i := f_x_to_zero(left.hmq_stat_out_i) or f_x_to_zero(right.hmq_stat_out_i);
tmp.rmq_stat_in_i := f_x_to_zero(left.rmq_stat_in_i) or f_x_to_zero(right.rmq_stat_in_i);
tmp.rmq_stat_out_i := f_x_to_zero(left.rmq_stat_out_i) or f_x_to_zero(right.rmq_stat_out_i);
tmp.wr_stat_link_ok_i := f_x_to_zero(left.wr_stat_link_ok_i) or f_x_to_zero(right.wr_stat_link_ok_i);
tmp.wr_stat_time_ok_i := f_x_to_zero(left.wr_stat_time_ok_i) or f_x_to_zero(right.wr_stat_time_ok_i);
tmp.wr_stat_aux_clock_ok_i := f_x_to_zero(left.wr_stat_aux_clock_ok_i) or f_x_to_zero(right.wr_stat_aux_clock_ok_i);
tmp.tai_cycles_i := f_x_to_zero(left.tai_cycles_i) or f_x_to_zero(right.tai_cycles_i);
tmp.tai_sec_i := f_x_to_zero(left.tai_sec_i) or f_x_to_zero(right.tai_sec_i);
tmp.delay_cnt_i := f_x_to_zero(left.delay_cnt_i) or f_x_to_zero(right.delay_cnt_i);
tmp.gpio_in_i := f_x_to_zero(left.gpio_in_i) or f_x_to_zero(right.gpio_in_i);
return tmp;
end function;
end package body;
