/*
 * SPDX-License-Identifier: LGPL-2.1-or-later
 * SPDX-FileCopyrightText: 2019 CERN (home.cern)
 */

  .section    .boot, "ax", @progbits

.global _start
_start:
    j _entry

.org 0x8

.extern trap_entry
_exception_entry:
  j trap_entry


_entry:

  .option push
  .option norelax
  la gp, __global_pointer$    /* Initialize global pointer */
  .option pop
  la sp, _fstack

  la t0, _fexception_stack
  csrrw t0, mscratch, t0

  /* clear the bss segment */
  la t0, _bss_start
  la t1, _end
1:
#ifdef __riscv64
  sd zero,0(t0)
  addi t0, t0, 8
#else
  sw zero,0(t0)
  addi t0, t0, 4
#endif
  bltu t0, t1, 1b
  call main
1:
  j     1b
